## openssh 10.1p1

=== debian/changelog ===
openssh (1:10.1p1-2) unstable; urgency=medium

  * Don't reuse c->isatty for signalling that the remote channel has a tty
    attached (closes: #1117574, #1117594).
  * Link ssh-keygen directly against ssh-pkcs11.c.

 -- Colin Watson <cjwatson@debian.org>  Thu, 09 Oct 2025 00:54:25 +0100

openssh (1:10.1p1-1) unstable; urgency=medium

  [ Allison Karlitskaya ]
  * sshd@.service: Support ephemeral keys from VM/container hosts.

  [ Colin Watson ]
  * New upstream release:
    - ssh(1): add a warning when the connection negotiates a non-post
      quantum key agreement algorithm.
    - ssh(1), sshd(8): major changes to handling of DSCP marking/IPQoS: by
      default, interactive traffic is assigned to the EF (Expedited
      Forwarding) class, while non-interactive traffic uses the operating
      system default DSCP marking.
    - ssh(1), sshd(8): deprecate support for IPv4 type-of-service (ToS)
      keywords in the IPQoS configuration directive.
    - ssh-add(1): when adding certificates to an agent, set the expiry to
      the certificate expiry time plus a short (5 min) grace period.
    - All: remove experimental support for XMSS keys.
    - ssh-agent(1), sshd(8): move agent listener sockets from /tmp to under
      ~/.ssh/agent for both ssh-agent(1) and forwarded sockets in sshd(8).
    - CVE-2025-61984: ssh(1): disallow control characters in usernames
      passed via the commandline or expanded using %-sequences from the
      configuration file (closes: #1117529),
    - CVE-2025-61985: ssh(1): disallow \0 characters in ssh:// URIs (closes:
      #1117530).
    - ssh(1), sshd(8): add SIGINFO handlers to log active channel and
      session information.
    - sshd(8): when refusing a certificate for user authentication, log
      enough information to identify the certificate in addition to the
      reason why it was being denied. Makes debugging certificate
      authorisation problems a bit easier.
    - ssh(1), ssh-agent(1): support ed25519 keys hosted on PKCS#11 tokens.
    - ssh(1): add an ssh_config(5) RefuseConnection option that, when
      encountered while processing an active section in a configuration,
      terminates ssh(1) with an error message that contains the argument to
      the option.
    - sshd(8): make the X11 display number check relative to
      X11DisplayOffset. This will allow people to use X11DisplayOffset to
      configure much higher port ranges if they really want, while not
      changing the default behaviour.
    - ssh(1): fix delay on X client startup when ObscureKeystrokeTiming is
      enabled.
    - sshd(8): increase the maximum size of the supported configuration from
      256KB to 4MB, which ought to be enough for anybody. Fail early and
      visibly when this limit is breached.
    - sftp(1): during sftp uploads, avoid a condition where a failed write
      could be ignored if a subsequent write succeeded. This is unlikely but
      technically possible because sftp servers are allowed to reorder
      requests.
    - sshd(8): avoid a race condition when the sshd-auth process exits that
      could cause a spurious error message to be logged.
    - sshd(8): log at level INFO when PerSourcePenalties actually blocks
      access to a source address range. Previously this was logged at level
      VERBOSE, which hid enforcement actions under default config settings.
    - sshd(8): Make the MaxStartups and PerSourceNetBlockSize options
      first-match-wins as advertised.
    - ssh(1): fix an incorrect return value check in the local forward
      cancellation path that would cause failed cancellations not to be
      logged.
    - sshd(8): make "Match !final" not trigger a second parsing pass of
      ssh_config (unless hostname canonicalisation or a separate "Match
      final" does).
    - ssh(1): better debug diagnostics when loading keys. Will now list key
      fingerprint and algorithm (not just algorithm number) as well as
      making it explicit which keys didn't load.
    - All: fix a number of memory leaks found by LeakSanitizer, Coverity and
      manual inspection.
    - sshd(8): Output the current name for PermitRootLogin's
      "prohibit-password" in sshd -T instead of its deprecated alias
      "without-password" (closes: #1095922).
    - ssh(1): make writing known_hosts lines more atomic by writing the
      entire line in one operation and using unbuffered stdio.
    - sshd(8): check the username didn't change during the PAM transactions.
    - sshd(8): don't log audit messages with UNKNOWN hostname to avoid slow
      DNS lookups in the audit subsystem.
    - All: when making a copy of struct passwd, ensure struct fields are
      non-NULL.
    - sshd(8): handle futex_time64 properly in seccomp sandbox.
    - Add contrib/gnome-ssh-askpass4 for GNOME 40+ using the GCR API.
    - ssh-agent(1): exit 0 from SIGTERM under systemd socket-activation,
      preventing a graceful shutdown of an agent via systemd from
      incorrectly marking the service as "failed".
  * Drop patches:
    - no-openssl-version-status.patch: Mostly applied upstream; the rest
      only applied to OpenSSL < 3, which isn't relevant to current Debian
      releases.
    - revert-ipqos-defaults.patch: This new upstream release reworks IPQoS,
      so let's see how that works in Debian (closes: #1111446).
  * debian/run-tests: Fix path to dropbear.

 -- Colin Watson <cjwatson@debian.org>  Tue, 07 Oct 2025 22:07:19 +0100

openssh (1:10.0p1-8) unstable; urgency=medium

  * Remove some long-obsolete Conflicts (closes: #54243).
  * Fix mistracking of MaxStartups process exits in some situations (closes:
    #1080350).

 -- Colin Watson <cjwatson@debian.org>  Sun, 10 Aug 2025 00:07:55 +0100

## openssh 10.2p1

=== regress/Makefile ===
#	$OpenBSD: Makefile,v 1.140 2025/07/04 07:52:17 djm Exp $

tests:		prep file-tests t-exec unit

REGRESS_TARGETS=	t1 t2 t3 t4 t5 t7 t9 t10 t11 t12

# File based tests
file-tests: $(REGRESS_TARGETS)

# Interop tests are not run by default
interop interop-tests: t-exec-interop

extra extra-tests: t-extra

prep:
	test "x${USE_VALGRIND}" = "x" || mkdir -p $(OBJ)/valgrind-out

clean:
	for F in $(CLEANFILES); do rm -f $(OBJ)$$F; done
	rm -rf $(OBJ).putty
	rm -rf $(OBJ).dropbear

distclean:	clean

LTESTS= 	connect \
		proxy-connect \
		sshfp-connect \
		connect-privsep \
		connect-uri \
		proto-version \
		proto-mismatch \
		exit-status \
		exit-status-signal \
		envpass \
		transfer \
		banner \
		rekey \
		dhgex \
		stderr-data \
		stderr-after-eof \
		broken-pipe \
		try-ciphers \
		yes-head \
		login-timeout \
		agent \
		agent-getpeereid \
		agent-timeout \
		agent-ptrace \
		agent-subprocess \
		keyscan \
		keygen-change \
		keygen-comment \
		keygen-convert \
		keygen-knownhosts \
		keygen-moduli \
		keygen-sshfp \
		key-options \
		scp \
		scp3 \
		scp-uri \
		sftp \
		sftp-chroot \
		sftp-cmds \
		sftp-badcmds \
		sftp-batch \
		sftp-glob \
		sftp-perm \
		sftp-resume \
		sftp-uri \
		reconfigure \
		dynamic-forward \
		forwarding \
		multiplex \
		reexec \
		brokenkeys \
		sshcfgparse \
		cfgparse \
		cfgmatch \
		cfgmatchlisten \
		percent \
		addrmatch \
		localcommand \
		forcecommand \
		portnum \
		keytype \
		kextype \
		cert-hostkey \
		cert-userkey \
		host-expand \
		keys-command \
		forward-control \
		integrity \
		krl \
		multipubkey \
		limit-keytype \
		hostkey-agent \
		hostkey-rotate \
		principals-command \
		cert-file \
		cfginclude \
		servcfginclude \
		allow-deny-users \
		authinfo \
		sshsig \
		knownhosts \
		knownhosts-command \
		agent-restrict \
		hostbased \
		password \
		channel-timeout \
		connection-timeout \
		match-subsystem \
		agent-pkcs11-restrict \
		agent-pkcs11-cert \
		penalty \
		penalty-expire \
		connect-bigconf

INTEROP_TESTS=	putty-transfer putty-ciphers putty-kex conch-ciphers
INTEROP_TESTS+=	dropbear-ciphers dropbear-kex dropbear-server
#INTEROP_TESTS+=ssh-com ssh-com-client ssh-com-keygen ssh-com-sftp

EXTRA_TESTS=	agent-pkcs11
#EXTRA_TESTS+= 	cipher-speed

USERNAME=		${LOGNAME}
CLEANFILES=	*.core actual agent-key.* authorized_keys_${USERNAME} \
		authorized_keys_${USERNAME}.* \
		authorized_principals_${USERNAME} \
		banner.in banner.out cert_host_key* cert_user_key* \
		copy.1 copy.2 data ed25519-agent ed25519-agent* \
		ed25519-agent.pub ed25519 ed25519.pub empty.in \
		expect failed-regress.log failed-ssh.log failed-sshd.log \
		hkr.* host.ecdsa-sha2-nistp256 host.ecdsa-sha2-nistp384 \
		host.ecdsa-sha2-nistp521 host.ssh-ed25519 \
		host.ssh-rsa host_ca_key* host_krl_* host_revoked_* key.* \
		key.ecdsa-* key.ed25519-512 \
		key.ed25519-512.pub key.rsa-* keys-command-args kh.* askpass \
		known_hosts known_hosts-cert known_hosts.* krl-* ls.copy \
		modpipe netcat no_identity_config \
		pidfile putty.rsa2 ready regress.log remote_pid \
		revoked-* rsa rsa-agent rsa-agent.pub rsa.pub rsa_ssh2_cr.prv \
		rsa_ssh2_crnl.prv scp-ssh-wrapper.exe \
		scp-ssh-wrapper.scp setuid-allowed sftp-server.log \
		sftp-server.sh sftp.log ssh-log-wrapper.sh ssh.log \
		ssh-agent.log ssh-add.log slow-sftp-server.sh \
		ssh-rsa_oldfmt knownhosts_command \
		ssh_config ssh_config.* ssh_proxy ssh_proxy_bak \
		ssh_proxy_* sshd.log sshd_config sshd_config.* \
		sshd_config.* sshd_proxy sshd_proxy.* sshd_proxy_bak \
		sshd_proxy_orig t10.out t10.out.pub t12.out t12.out.pub \
		t2.out t3.out t6.out1 t6.out2 t7.out t7.out.pub \
		t8.out t8.out.pub t9.out t9.out.pub \
		timestamp testdata user_*key* user_ca* user_key*

# Enable all malloc(3) randomisations and checks
TEST_ENV=      "MALLOC_OPTIONS=CFGJRSUX"

TEST_SSH_SSHKEYGEN?=ssh-keygen

CPPFLAGS=-I..

t1:
	set -xe ; if ${TEST_SSH_SSH} -Q key | grep -q "^ssh-rsa" ; then \
		${TEST_SSH_SSHKEYGEN} -if ${.CURDIR}/rsa_ssh2.prv | diff - ${.CURDIR}/rsa_openssh.prv ; \
		tr '\n' '\r' <${.CURDIR}/rsa_ssh2.prv > ${.OBJDIR}/rsa_ssh2_cr.prv ; \
		${TEST_SSH_SSHKEYGEN} -if ${.OBJDIR}/rsa_ssh2_cr.prv | diff - ${.CURDIR}/rsa_openssh.prv ; \
		awk '{print $$0 "\r"}' ${.CURDIR}/rsa_ssh2.prv > ${.OBJDIR}/rsa_ssh2_crnl.prv ; \
		${TEST_SSH_SSHKEYGEN} -if ${.OBJDIR}/rsa_ssh2_crnl.prv | diff - ${.CURDIR}/rsa_openssh.prv ; \
	fi

t2:
	set -xe ; if ${TEST_SSH_SSH} -Q key | grep -q "^ssh-rsa" ; then \
		cat ${.CURDIR}/rsa_openssh.prv > $(OBJ)/t2.out ; \
		chmod 600 $(OBJ)/t2.out ; \
		${TEST_SSH_SSHKEYGEN} -yf $(OBJ)/t2.out | diff - ${.CURDIR}/rsa_openssh.pub ; \
	fi

t3:
	set -xe ; if ${TEST_SSH_SSH} -Q key | grep -q "^ssh-rsa" ; then \
		${TEST_SSH_SSHKEYGEN} -ef ${.CURDIR}/rsa_openssh.pub >$(OBJ)/t3.out ; \
		${TEST_SSH_SSHKEYGEN} -if $(OBJ)/t3.out | diff - ${.CURDIR}/rsa_openssh.pub ; \
	fi

t4:
	set -xe ; if ${TEST_SSH_SSH} -Q key | grep -q "^ssh-rsa" ; then \
		${TEST_SSH_SSHKEYGEN} -E md5 -lf ${.CURDIR}/rsa_openssh.pub |\
			awk '{print $$2}' | diff - ${.CURDIR}/t4.ok ; \
	fi

t5:
	set -xe ; if ${TEST_SSH_SSH} -Q key | grep -q "^ssh-rsa" ; then \
		${TEST_SSH_SSHKEYGEN} -Bf ${.CURDIR}/rsa_openssh.pub |\
			awk '{print $$2}' | diff - ${.CURDIR}/t5.ok ; \
	fi

$(OBJ)/t7.out:
	set -xe ; if ${TEST_SSH_SSH} -Q key | grep -q "^ssh-rsa" ; then \
		${TEST_SSH_SSHKEYGEN} -q -t rsa -N '' -f $@ ; \
	fi

t7: $(OBJ)/t7.out
	set -xe ; if ${TEST_SSH_SSH} -Q key | grep -q "^ssh-rsa" ; then \
		${TEST_SSH_SSHKEYGEN} -lf $(OBJ)/t7.out > /dev/null ; \
		${TEST_SSH_SSHKEYGEN} -Bf $(OBJ)/t7.out > /dev/null ; \
	fi

$(OBJ)/t9.out:
	! ${TEST_SSH_SSH} -Q key-plain | grep ecdsa >/dev/null || \
	${TEST_SSH_SSHKEYGEN} -q -t ecdsa -N '' -f $@

t9: $(OBJ)/t9.out
	! ${TEST_SSH_SSH} -Q key-plain | grep ecdsa >/dev/null || \
	${TEST_SSH_SSHKEYGEN} -lf $(OBJ)/t9.out > /dev/null
	! ${TEST_SSH_SSH} -Q key-plain | grep ecdsa >/dev/null || \
	${TEST_SSH_SSHKEYGEN} -Bf $(OBJ)/t9.out > /dev/null


$(OBJ)/t10.out:
	${TEST_SSH_SSHKEYGEN} -q -t ed25519 -N '' -f $@

t10: $(OBJ)/t10.out
	${TEST_SSH_SSHKEYGEN} -lf $(OBJ)/t10.out > /dev/null
	${TEST_SSH_SSHKEYGEN} -Bf $(OBJ)/t10.out > /dev/null

t11:
	set -xe ; if ${TEST_SSH_SSH} -Q key | grep -q "^ssh-rsa" ; then \
		${TEST_SSH_SSHKEYGEN} -E sha256 -lf ${.CURDIR}/rsa_openssh.pub |\
			awk '{print $$2}' | diff - ${.CURDIR}/t11.ok ; \
	fi

$(OBJ)/t12.out:
	${TEST_SSH_SSHKEYGEN} -q -t ed25519 -N '' -C 'test-comment-1234' -f $@

t12: $(OBJ)/t12.out
	${TEST_SSH_SSHKEYGEN} -lf $(OBJ)/t12.out.pub | grep test-comment-1234 >/dev/null

t-exec:	${LTESTS:=.sh}
	@if [ "x$?" = "x" ]; then exit 0; fi; \
	_started=""; test -z "${LTESTS_FROM}" && _started=1 ;\
	for TEST in ""$?; do \
		if [ -z "$$_started" ] ; then \
			if [ "x$$TEST" = "x${LTESTS_FROM}.sh" ]; then \
				_started=1; \
			else \
				continue; \
			fi ; \
		fi ; \
		skip=no; \
		for t in ""$${SKIP_LTESTS}; do \
			if [ "x$${t}.sh" = "x$${TEST}" ]; then skip=yes; fi; \
		done; \
		if [ "x$${skip}" = "xno" ]; then \
			echo "run test $${TEST}" ... 1>&2; \
			(env SUDO="${SUDO}" TEST_ENV=${TEST_ENV} ${TEST_SHELL} ${.CURDIR}/test-exec.sh ${.OBJDIR} ${.CURDIR}/$${TEST}) || exit $$?; \
		else \
			echo skip test $${TEST} 1>&2; \
		fi; \
	done

t-exec-interop:	${INTEROP_TESTS:=.sh}
	@if [ "x$?" = "x" ]; then exit 0; fi; \
	for TEST in ""$?; do \
		echo "run test $${TEST}" ... 1>&2; \
		(env SUDO="${SUDO}" TEST_ENV=${TEST_ENV} ${TEST_SHELL} ${.CURDIR}/test-exec.sh ${.OBJDIR} ${.CURDIR}/$${TEST}) || exit $$?; \
	done

t-extra:	${EXTRA_TESTS:=.sh}
	@if [ "x$?" = "x" ]; then exit 0; fi; \
	for TEST in ""$?; do \
		echo "run test $${TEST}" ... 1>&2; \
		(env SUDO="${SUDO}" TEST_ENV=${TEST_ENV} ${TEST_SHELL} ${.CURDIR}/test-exec.sh ${.OBJDIR} ${.CURDIR}/$${TEST}) || exit $$?; \
	done

# Not run by default
interop: ${INTEROP_TARGETS}

# Unit tests, built by top-level Makefile
unit unit-bench:
	set -e ; if test -z "${SKIP_UNIT}" ; then \
		V="" ; \
		test "x${USE_VALGRIND}" = "x" || \
		    V=${.CURDIR}/valgrind-unit.sh ; \
		ARGS=""; \
		test "x$@" = "xunit-bench" && ARGS="-b"; \
		test "x${UNITTEST_FAST}" = "x" || ARGS="$$ARGS -f"; \
		test "x${UNITTEST_SLOW}" = "x" || ARGS="$$ARGS -F"; \
		test "x${UNITTEST_VERBOSE}" = "x" || ARGS="$$ARGS -v"; \
		test "x${UNITTEST_BENCH_DETAIL}" = "x" || ARGS="$$ARGS -B"; \
		test "x${UNITTEST_BENCH_ONLY}" = "x" || ARGS="$$ARGS -O ${UNITTEST_BENCH_ONLY}"; \
		 $$V ${.OBJDIR}/unittests/sshbuf/test_sshbuf $${ARGS}; \
		 $$V ${.OBJDIR}/unittests/sshkey/test_sshkey \
			-d ${.CURDIR}/unittests/sshkey/testdata $${ARGS}; \
		$$V ${.OBJDIR}/unittests/sshsig/test_sshsig \
			-d ${.CURDIR}/unittests/sshsig/testdata $${ARGS}; \
		$$V ${.OBJDIR}/unittests/authopt/test_authopt \
			-d ${.CURDIR}/unittests/authopt/testdata $${ARGS}; \
		$$V ${.OBJDIR}/unittests/bitmap/test_bitmap $${ARGS}; \
		$$V ${.OBJDIR}/unittests/conversion/test_conversion $${ARGS}; \
		$$V ${.OBJDIR}/unittests/kex/test_kex $${ARGS}; \
		$$V ${.OBJDIR}/unittests/hostkeys/test_hostkeys \
			-d ${.CURDIR}/unittests/hostkeys/testdata $${ARGS}; \
		$$V ${.OBJDIR}/unittests/match/test_match $${ARGS}; \
		$$V ${.OBJDIR}/unittests/misc/test_misc $${ARGS}; \
		if test "x${TEST_SSH_UTF8}" = "xyes"  ; then \
			$$V ${.OBJDIR}/unittests/utf8/test_utf8 $${ARGS}; \
		fi \
	fi

=== regress/unittests/Makefile ===
#	$OpenBSD: Makefile,v 1.13 2023/09/24 08:14:13 claudio Exp $

SUBDIR=	test_helper sshbuf sshkey bitmap kex hostkeys utf8 match conversion
SUBDIR+=authopt misc sshsig

.include <bsd.subdir.mk>

=== regress/misc/ssh-verify-attestation/Makefile ===
#	$OpenBSD: Makefile,v 1.2 2025/05/06 06:05:48 djm Exp $

.include <bsd.own.mk>
.include <bsd.obj.mk>

PROG=	ssh-verify-attestation
NOMAN=

SSHREL=../../../../../usr.bin/ssh
.PATH: ${.CURDIR}/${SSHREL}

SRCS=ssh-verify-attestation.c
# From usr.bin/ssh
SRCS+=sshbuf-getput-basic.c sshbuf-getput-crypto.c sshbuf-misc.c sshbuf.c
SRCS+=sshbuf-io.c atomicio.c sshkey.c authfile.c cipher.c log.c ssh-rsa.c
SRCS+=ssh-ecdsa.c ssh-ed25519.c mac.c umac.c umac128.c hmac.c misc.c
SRCS+=ssherr.c uidswap.c cleanup.c xmalloc.c match.c krl.c fatal.c
SRCS+=addr.c addrmatch.c bitmap.c
SRCS+=ed25519.c hash.c
SRCS+=cipher-chachapoly.c chacha.c poly1305.c ssh-ecdsa-sk.c ssh-sk.c
SRCS+=ssh-ed25519-sk.c sk-usbhid.c

SRCS+=digest-openssl.c
#SRCS+=digest-libc.c
SRCS+=utf8.c

OPENSSL?=	yes

.if (${OPENSSL:L} == "yes")
CFLAGS+=	-DWITH_OPENSSL
.endif

# enable warnings
WARNINGS=Yes

DEBUG=-g
CFLAGS+=	-fstack-protector-all
CDIAGFLAGS=	-Wall
CDIAGFLAGS+=	-Wextra
CDIAGFLAGS+=	-Werror
CDIAGFLAGS+=	-Wchar-subscripts
CDIAGFLAGS+=	-Wcomment
CDIAGFLAGS+=	-Wformat
CDIAGFLAGS+=	-Wformat-security
CDIAGFLAGS+=	-Wimplicit
CDIAGFLAGS+=	-Winline
CDIAGFLAGS+=	-Wmissing-declarations
CDIAGFLAGS+=	-Wmissing-prototypes
CDIAGFLAGS+=	-Wparentheses
CDIAGFLAGS+=	-Wpointer-arith
CDIAGFLAGS+=	-Wreturn-type
CDIAGFLAGS+=	-Wshadow
CDIAGFLAGS+=	-Wsign-compare
CDIAGFLAGS+=	-Wstrict-aliasing
CDIAGFLAGS+=	-Wstrict-prototypes
CDIAGFLAGS+=	-Wswitch
CDIAGFLAGS+=	-Wtrigraphs
CDIAGFLAGS+=	-Wuninitialized
CDIAGFLAGS+=	-Wunused
CDIAGFLAGS+=	-Wno-unused-parameter
.if ${COMPILER_VERSION:L} != "gcc3"
CDIAGFLAGS+=	-Wold-style-definition
.endif

CFLAGS+=-I${.CURDIR}/${SSHREL}

.if (${OPENSSL:L} == "yes")
LDADD+= -lcrypto
DPADD+= ${LIBCRYPTO}
.endif

LDADD+= -lfido2 -lcbor
DPADD+= ${LIBFIDO2} ${LIBCBOR}

LDADD+= -lutil
DPADD+= ${LIBUTIL}

.include <bsd.prog.mk>

=== regress/unittests/hostkeys/Makefile ===
#	$OpenBSD: Makefile,v 1.13 2025/07/24 06:04:47 djm Exp $

PROG=test_hostkeys
SRCS=tests.c test_iterate.c

# From usr.bin/ssh
SRCS+=sshbuf-getput-basic.c sshbuf-getput-crypto.c sshbuf-misc.c sshbuf.c
SRCS+=sshbuf-io.c atomicio.c sshkey.c authfile.c cipher.c log.c ssh-rsa.c
SRCS+=ssh-ecdsa.c ssh-ed25519.c mac.c umac.c umac128.c hmac.c misc.c
SRCS+=ssherr.c uidswap.c cleanup.c xmalloc.c match.c krl.c fatal.c
SRCS+=addr.c addrmatch.c bitmap.c hostfile.c
SRCS+=ed25519.c hash.c
SRCS+=cipher-chachapoly.c chacha.c poly1305.c ssh-ecdsa-sk.c ssh-sk.c
SRCS+=ssh-ed25519-sk.c sk-usbhid.c ssh-pkcs11-client.c

SRCS+=digest-openssl.c
#SRCS+=digest-libc.c
SRCS+=utf8.c

REGRESS_TARGETS=run-regress-${PROG}

run-regress-${PROG}: ${PROG}
	env ${TEST_ENV} ./${PROG} ${UNITTEST_ARGS} -d ${.CURDIR}/testdata

.include <bsd.regress.mk>

=== regress/unittests/match/Makefile ===
#	$OpenBSD: Makefile,v 1.6 2025/04/15 04:00:42 djm Exp $

PROG=test_match
SRCS=tests.c

# From usr.bin/ssh
SRCS+=sshbuf-getput-basic.c sshbuf-getput-crypto.c sshbuf-misc.c sshbuf.c
SRCS+=match.c misc.c log.c uidswap.c fatal.c ssherr.c addrmatch.c xmalloc.c
SRCS+=cleanup.c atomicio.c addr.c

REGRESS_TARGETS=run-regress-${PROG}

run-regress-${PROG}: ${PROG}
	env ${TEST_ENV} ./${PROG} ${UNITTEST_ARGS}

.include <bsd.regress.mk>

=== regress/unittests/sshsig/Makefile ===
#	$OpenBSD: Makefile,v 1.5 2025/07/24 06:04:47 djm Exp $

PROG=test_sshsig
SRCS=tests.c

# From usr.bin/ssh
SRCS+=sshbuf-getput-basic.c sshbuf-getput-crypto.c sshbuf-misc.c sshbuf.c
SRCS+=sshbuf-io.c atomicio.c sshkey.c authfile.c cipher.c log.c ssh-rsa.c
SRCS+=ssh-ecdsa.c ssh-ed25519.c mac.c umac.c umac128.c hmac.c misc.c
SRCS+=ssherr.c uidswap.c cleanup.c xmalloc.c match.c krl.c fatal.c
SRCS+=addr.c addrmatch.c bitmap.c sshsig.c
SRCS+=ed25519.c hash.c
SRCS+=cipher-chachapoly.c chacha.c poly1305.c ssh-ecdsa-sk.c ssh-sk.c
SRCS+=ssh-ed25519-sk.c sk-usbhid.c ssh-pkcs11-client.c

SRCS+=digest-openssl.c
#SRCS+=digest-libc.c
SRCS+=utf8.c

REGRESS_TARGETS=run-regress-${PROG}

run-regress-${PROG}: ${PROG}
	env ${TEST_ENV} ./${PROG} ${UNITTEST_ARGS} -d ${.CURDIR}/testdata

.include <bsd.regress.mk>

=== regress/unittests/utf8/Makefile ===
#	$OpenBSD: Makefile,v 1.6 2025/04/15 04:00:42 djm Exp $

PROG=test_utf8
SRCS=tests.c

# From usr.bin/ssh
SRCS+=utf8.c atomicio.c misc.c xmalloc.c match.c ssherr.c cleanup.c fatal.c
SRCS+=sshbuf.c sshbuf-getput-basic.c sshbuf-misc.c addr.c addrmatch.c log.c

REGRESS_TARGETS=run-regress-${PROG}

run-regress-${PROG}: ${PROG}
	env ${TEST_ENV} ./${PROG} ${UNITTEST_ARGS}

.include <bsd.regress.mk>

=== debian/changelog ===
openssh (1:10.2p1-5) unstable; urgency=medium

  [ Samuel Thibault ]
  * Do not link against libcrypt on GNU/Hurd (closes: #1128399).

  [ Colin Watson ]
  * Install systemd files directly to /usr and drop dh-sequence-movetousr
    (closes: #1122765).

 -- Colin Watson <cjwatson@debian.org>  Thu, 19 Feb 2026 10:46:15 +0000

openssh (1:10.2p1-4) unstable; urgency=medium

  [ Colin Watson ]
  * Debconf translations:
    - Simplified and Traditional Chinese (thanks, Yangfl; closes: #1124970).

  [ Luca Boccassi ]
  * openssh-client: use sysusers.d instead of manual scripting.
  * openssh-client: drop compat postinst not needed since bookworm/noble.
  * openssh-client: drop versioned dependency on i-s-h, satisfied since
    trixie/noble.
  * openssh-client: drop dependency on passwd, add recommends on
    openssh-server.
  * Use dh-sequence-installsysusers and drop d/rules override.

  [ Christian Göttsche ]
  * Reorder pam_selinux(7) usage (closes: #747303).

 -- Colin Watson <cjwatson@debian.org>  Wed, 18 Feb 2026 14:09:13 +0000

openssh (1:10.2p1-3) unstable; urgency=medium

  * Drop "Rules-Requires-Root: no", default as of dpkg-dev 1.22.13.
  * Drop openssh-server's dependency on lsb-base.
  * Remove support for direct upgrades from before Debian 12 (bookworm).
  * Rewrite scp-quoting.patch using argv_assemble, and forward it upstream.

 -- Colin Watson <cjwatson@debian.org>  Tue, 02 Dec 2025 14:36:37 +0000

openssh (1:10.2p1-2) unstable; urgency=medium

  * ssh-session-cleanup: Update pattern for sshd-session split in 9.8
    (closes: #1117965).
  * Link ssh against ssh-pkcs11.o directly (closes: #1117638, #1117720).

 -- Colin Watson <cjwatson@debian.org>  Fri, 17 Oct 2025 10:14:14 +0100

openssh (1:10.2p1-1) unstable; urgency=medium

  * New upstream release:
    - ssh-keygen(1): fix download of keys from PKCS#11 tokens.

 -- Colin Watson <cjwatson@debian.org>  Fri, 10 Oct 2025 14:50:27 +0100

=== debian/control ===
Source: openssh
Section: net
Priority: standard
Maintainer: Debian OpenSSH Maintainers <debian-ssh@lists.debian.org>
Build-Depends:
 debhelper (>= 13.1~),
 debhelper-compat (= 13),
 dh-exec,
 dh-runit (>= 2.8.8),
 dh-sequence-installsysusers,
 libaudit-dev [linux-any],
 libedit-dev,
 libfido2-dev (>= 1.5.0) [linux-any],
 libgtk-3-dev <!pkg.openssh.nognome>,
 libkrb5-dev | heimdal-dev,
 libpam0g-dev | libpam-dev,
 libselinux1-dev [linux-any],
 libssl-dev (>= 1.1.1),
 libwrap0-dev | libwrap-dev,
 libwtmpdb-dev,
 pkgconf,
 zlib1g-dev,
Standards-Version: 4.6.2
Uploaders:
 Colin Watson <cjwatson@debian.org>,
 Matthew Vernon <matthew@debian.org>,
Homepage: https://www.openssh.com/
Vcs-Git: https://salsa.debian.org/ssh-team/openssh.git
Vcs-Browser: https://salsa.debian.org/ssh-team/openssh
X-Style: black

Package: openssh-client
Architecture: any
Depends:
 ${misc:Depends},
 ${shlibs:Depends},
Recommends:
 xauth,
Breaks:
 openssh-sk-helper,
Replaces:
 openssh-sk-helper,
 ssh,
 ssh-krb5,
Suggests:
 keychain,
 libpam-ssh,
 monkeysphere,
 ssh-askpass,
Provides:
 ssh-client,
Multi-Arch: foreign
Description: secure shell (SSH) client, for secure access to remote machines
 This is the portable version of OpenSSH, a free implementation of
 the Secure Shell protocol as specified by the IETF secsh working
 group.
 .
 Ssh (Secure Shell) is a program for logging into a remote machine
 and for executing commands on a remote machine.
 It provides secure encrypted communications between two untrusted
 hosts over an insecure network. X11 connections and arbitrary TCP/IP
 ports can also be forwarded over the secure channel.
 It can be used to provide applications with a secure communication
 channel.
 .
 This package provides the ssh, scp and sftp clients, the ssh-agent
 and ssh-add programs to make public key authentication more convenient,
 and the ssh-keygen, ssh-keyscan, ssh-copy-id and ssh-argv0 utilities.
 .
 In some countries it may be illegal to use any encryption at all
 without a special permit.
 .
 ssh replaces the insecure rsh, rcp and rlogin programs, which are
 obsolete for most purposes.

Package: openssh-client-gssapi
Priority: optional
Architecture: all
Depends:
 openssh-client (>= ${binary:Version}),
 ${misc:Depends},
Multi-Arch: foreign
Description: secure shell (SSH) client, with GSS-API support
 This is the portable version of OpenSSH, a free implementation of
 the Secure Shell protocol as specified by the IETF secsh working
 group.
 .
 Ssh (Secure Shell) is a program for logging into a remote machine
 and for executing commands on a remote machine.
 It provides secure encrypted communications between two untrusted
 hosts over an insecure network. X11 connections and arbitrary TCP/IP
 ports can also be forwarded over the secure channel.
 It can be used to provide applications with a secure communication
 channel.
 .
 This package provides versions of the ssh client and related programs
 built with support for GSS-API authentication and key exchange, which
 can be used with systems such as Kerberos.
 It is currently an empty package depending on openssh-client, but
 future releases will remove GSS-API support from openssh-client, so
 users who need it should install this package.

Package: openssh-server
Priority: optional
Architecture: any
Pre-Depends:
 ${misc:Pre-Depends},
Depends:
 libpam-modules,
 libpam-runtime,
 openssh-client (= ${binary:Version}),
 openssh-sftp-server,
 procps,
 ucf,
 ${misc:Depends},
 ${shlibs:Depends},
Recommends:
 default-logind | logind | libpam-systemd,
 ncurses-term,
 passwd,
 xauth,
 ${openssh-server:Recommends},
Replaces:
 ssh,
 ssh-krb5,
Breaks:
 ${runit:Breaks},
Suggests:
 molly-guard,
 monkeysphere,
 ssh-askpass,
 ufw,
Provides:
 ssh-server,
Multi-Arch: foreign
Description: secure shell (SSH) server, for secure access from remote machines
 This is the portable version of OpenSSH, a free implementation of
 the Secure Shell protocol as specified by the IETF secsh working
 group.
 .
 Ssh (Secure Shell) is a program for logging into a remote machine
 and for executing commands on a remote machine.
 It provides secure encrypted communications between two untrusted
 hosts over an insecure network. X11 connections and arbitrary TCP/IP
 ports can also be forwarded over the secure channel.
 It can be used to provide applications with a secure communication
 channel.
 .
 This package provides the sshd server.
 .
 In some countries it may be illegal to use any encryption at all
 without a special permit.
 .
 sshd replaces the insecure rshd program, which is obsolete for most
 purposes.

Package: openssh-server-gssapi
Priority: optional
Architecture: all
Depends:
 openssh-client-gssapi (>= ${binary:Version}),
 openssh-server (>= ${binary:Version}),
 ${misc:Depends},
Multi-Arch: foreign
Description: secure shell (SSH) server, with GSS-API key exchange
 This is the portable version of OpenSSH, a free implementation of
 the Secure Shell protocol as specified by the IETF secsh working
 group.
 .
 Ssh (Secure Shell) is a program for logging into a remote machine
 and for executing commands on a remote machine.
 It provides secure encrypted communications between two untrusted
 hosts over an insecure network. X11 connections and arbitrary TCP/IP
 ports can also be forwarded over the secure channel.
 It can be used to provide applications with a secure communication
 channel.
 .
 This package provides a version of the sshd server built with support
 for GSS-API authentication and key exchange, which can be used with
 systems such as Kerberos.
 It is currently an empty package depending on openssh-server, but
 future releases will remove GSS-API support from openssh-server, so
 users who need it should install this package.

Package: openssh-sftp-server
Priority: optional
Architecture: any
Depends:
 ${misc:Depends},
 ${shlibs:Depends},
Recommends:
 openssh-server | ssh-server,
Breaks:
 openssh-server (<< 1:6.5p1-5),
Replaces:
 openssh-server (<< 1:6.5p1-5),
Enhances:
 openssh-server,
 ssh-server,
Multi-Arch: foreign
Description: secure shell (SSH) sftp server module, for SFTP access from remote machines
 This is the portable version of OpenSSH, a free implementation of
 the Secure Shell protocol as specified by the IETF secsh working
 group.
 .
 Ssh (Secure Shell) is a program for logging into a remote machine
 and for executing commands on a remote machine.
 It provides secure encrypted communications between two untrusted
 hosts over an insecure network. X11 connections and arbitrary TCP/IP
 ports can also be forwarded over the secure channel.
 It can be used to provide applications with a secure communication
 channel.
 .
 This package provides the SFTP server module for the SSH server. It
 is needed if you want to access your SSH server with SFTP. The SFTP
 server module also works with other SSH daemons like dropbear.
 .
 OpenSSH's sftp and sftp-server implement revision 3 of the SSH filexfer
 protocol described in:
 .
  http://www.openssh.com/txt/draft-ietf-secsh-filexfer-02.txt
 .
 Newer versions of the draft will not be supported, though some features
 are individually implemented as extensions.

Package: openssh-tests
Priority: optional
Architecture: any
Depends:
 openssh-client (= ${binary:Version}),
 openssh-server (= ${binary:Version}),
 openssh-sftp-server (= ${binary:Version}),
 openssl,
 putty-tools (>= 0.67-2),
 python3-twisted,
 ${misc:Depends},
 ${shlibs:Depends},
Multi-Arch: foreign
Description: OpenSSH regression tests
 This package provides OpenSSH's regression test suite.  It is mainly
 intended for use with the autopkgtest system, though can also be run
 directly using /usr/lib/openssh/regress/run-tests.

Package: ssh
Priority: optional
Architecture: all
Depends:
 openssh-client (>= ${binary:Version}),
 openssh-server (>= ${binary:Version}),
 ${misc:Depends},
Multi-Arch: foreign
Description: secure shell client and server (metapackage)
 This metapackage is a convenient way to install both the OpenSSH client
 and the OpenSSH server. It provides nothing in and of itself, so you
 may remove it if nothing depends on it.

Package: ssh-askpass-gnome
Build-Profiles: <!pkg.openssh.nognome>
Section: gnome
Priority: optional
Architecture: any
Depends:
 openssh-client | ssh (>= 1:1.2pre7-4),
 ${misc:Depends},
 ${shlibs:Depends},
Replaces:
 ssh (<< 1:3.5p1-3),
Provides:
 ssh-askpass,
Multi-Arch: foreign
Description: interactive X program to prompt users for a passphrase for ssh-add
 This has been split out of the main openssh-client package so that
 openssh-client does not need to depend on GTK+.
 .
 You probably want the ssh-askpass package instead, but this is
 provided to add to your choice and/or confusion.

Package: openssh-client-udeb
Build-Profiles: <!noudeb>
Package-Type: udeb
Section: debian-installer
Priority: optional
Architecture: any
Depends:
 ${misc:Depends},
 ${shlibs:Depends},
XB-Installer-Menu-Item: 99999
Description: secure shell client for the Debian installer
 This is the portable version of OpenSSH, a free implementation of
 the Secure Shell protocol as specified by the IETF secsh working
 group.
 .
 This package provides the ssh client for use in debian-installer.

Package: openssh-server-udeb
Build-Profiles: <!noudeb>
Package-Type: udeb
Section: debian-installer
Priority: optional
Architecture: any
Depends:
 ${misc:Depends},
 ${shlibs:Depends},
Description: secure shell server for the Debian installer
 This is the portable version of OpenSSH, a free implementation of
 the Secure Shell protocol as specified by the IETF secsh working
 group.
 .
 This package provides the sshd server for use in debian-installer.
 Since it is expected to be used in specialized situations (e.g. S/390
 installs with no console), it does not provide any configuration.

=== debian/rules ===
#!/usr/bin/make -f

export DEB_BUILD_MAINT_OPTIONS := hardening=+all

include /usr/share/dpkg/default.mk

# Uncomment this to turn on verbose mode.
# export DH_VERBOSE=1

# This has to be exported to make some magic below work.
export DH_OPTIONS

ifeq (,$(filter nocheck,$(DEB_BUILD_OPTIONS)))
  RUN_TESTS := yes
else
  RUN_TESTS :=
endif

ifeq (,$(filter parallel=%,$(DEB_BUILD_OPTIONS)))
  PARALLEL :=
else
  PARALLEL := \
	-j$(patsubst parallel=%,%,$(filter parallel=%,$(DEB_BUILD_OPTIONS)))
endif

ifeq ($(DEB_BUILD_GNU_TYPE),$(DEB_HOST_GNU_TYPE))
  CC := gcc
  PKG_CONFIG = pkg-config
else
  CC := $(DEB_HOST_GNU_TYPE)-gcc
  PKG_CONFIG = $(DEB_HOST_GNU_TYPE)-pkg-config
  RUN_TESTS :=
endif

# Change the version string to reflect distribution
SSH_EXTRAVERSION := $(DEB_VENDOR)-$(shell echo '$(DEB_VERSION)' | sed -e 's/.*-//; s/+salsaci+.*/+salsaci/')

UBUNTU := $(shell $(call dpkg_vendor_derives_from,Ubuntu))
ifeq ($(UBUNTU),yes)
DEFAULT_PATH := /usr/local/sbin:/usr/local/bin:/usr/sbin:/usr/bin:/sbin:/bin:/usr/games
else
DEFAULT_PATH := /usr/local/bin:/usr/bin:/bin:/usr/games
endif
SUPERUSER_PATH := /usr/local/sbin:/usr/local/bin:/usr/sbin:/usr/bin:/sbin:/bin

ifeq ($(UBUNTU),yes)
server_recommends := ssh-import-id
else
server_recommends :=
endif

# Common path configuration.
confflags += --sysconfdir=/etc/ssh
confflags += --libexecdir=\$${prefix}/lib/openssh

# Common build options.
confflags += --disable-strip
confflags += --with-mantype=doc
confflags += --with-4in6
confflags += --with-privsep-path=/run/sshd
confflags += --with-pid-dir=/run

# Always use the internal mkdtemp; see https://bugs.debian.org/1001186.
confflags += ac_cv_func_mkdtemp=no

# ppc64el doesn't support -fzero-call-used-regs=used, but configure fails to
# detect that.
ifeq ($(DEB_HOST_ARCH),ppc64el)
confflags += ossh_cv_cflag__fzero_call_used_regs_used=no
endif

# passwd isn't otherwise needed and may not be installed at build time.
# Ensure that sshd knows its path.
confflags += PATH_PASSWD_PROG=/usr/bin/passwd

# Everything above here is common to the deb and udeb builds.
confflags_udeb := $(confflags)

# Options specific to the deb build.
confflags += --with-tcp-wrappers
confflags += --with-pam
confflags += --with-libedit
confflags += --with-kerberos5=/usr
confflags += --with-ssl-engine
confflags += --with-wtmpdb
ifeq ($(DEB_HOST_ARCH_OS),linux)
confflags += --with-selinux
confflags += --with-audit=linux
confflags += --with-security-key-builtin
endif

# The deb build wants xauth; the udeb build doesn't.
confflags += --with-xauth=/usr/bin/xauth
confflags_udeb += --without-xauth

# Default paths. The udeb build has /usr/games removed.
confflags += --with-default-path=$(DEFAULT_PATH) --with-superuser-path=$(SUPERUSER_PATH)
confflags_udeb += --with-default-path=/usr/local/bin:/usr/bin:/bin --with-superuser-path=/usr/local/sbin:/usr/local/bin:/usr/sbin:/usr/bin:/sbin:/bin

# Compiler flags.
cflags := $(CPPFLAGS) $(CFLAGS)
cflags += -DSSH_EXTRAVERSION=\"$(SSH_EXTRAVERSION)\"
cflags_udeb := -Os
cflags_udeb += -DSSH_EXTRAVERSION=\"$(SSH_EXTRAVERSION)\"
confflags += --with-cflags='$(cflags)'
confflags_udeb += --with-cflags='$(cflags_udeb)'

# Linker flags.
confflags += --with-ldflags='$(strip -Wl,--as-needed $(LDFLAGS))'
confflags_udeb += --with-ldflags='-Wl,--as-needed'

ifeq ($(shell dpkg-vendor --is Ubuntu && echo yes) $(DEB_HOST_ARCH), yes i386)
  BUILD_PACKAGES += -Nopenssh-tests
endif

%:
	dh $@ --with=runit $(BUILD_PACKAGES)

override_dh_autoreconf-indep:

override_dh_auto_configure-arch:
	dh_auto_configure -Bdebian/build-deb -- $(confflags)
ifeq ($(filter noudeb,$(DEB_BUILD_PROFILES)),)
	dh_auto_configure -Bdebian/build-udeb -- $(confflags_udeb)
	# Avoid libnsl linkage. Ugh.
	perl -pi -e 's/ +-lnsl//' debian/build-udeb/config.status
	cd debian/build-udeb && ./config.status
endif

	# Nothing reads /var/log/btmp any more (see
	# https://bugs.debian.org/1072184).
	perl -pi -e 's,.*#define USE_BTMP .*,/* #undef USE_BTMP */,' debian/build-deb/config.h
ifeq ($(filter noudeb,$(DEB_BUILD_PROFILES)),)
	perl -pi -e 's,.*#define USE_BTMP .*,/* #undef USE_BTMP */,' debian/build-udeb/config.h
endif

override_dh_auto_configure-indep:

override_dh_auto_build-arch:
	$(MAKE) -C debian/build-deb $(PARALLEL) ASKPASS_PROGRAM='/usr/bin/ssh-askpass'
	$(MAKE) -C debian/build-deb regress-prep
	$(MAKE) -C debian/build-deb $(PARALLEL) regress-binaries regress-unit-binaries
ifeq ($(filter noudeb,$(DEB_BUILD_PROFILES)),)
	$(MAKE) -C debian/build-udeb $(PARALLEL) ASKPASS_PROGRAM='/usr/bin/ssh-askpass' ssh scp sftp sshd ssh-keygen sshd-auth sshd-session
endif

ifeq ($(filter pkg.openssh.nognome,$(DEB_BUILD_PROFILES)),)
	$(MAKE) -C contrib gnome-ssh-askpass3 CC='$(CC) $(CPPFLAGS) $(CFLAGS) -Wall -Wl,--as-needed $(LDFLAGS)' PKG_CONFIG=$(PKG_CONFIG)
endif

override_dh_auto_build-indep:

override_dh_auto_test-arch:
ifeq ($(RUN_TESTS),yes)
	$(MAKE) -C debian/build-deb unit compat-tests
	$(MAKE) -C debian/keygen-test
	debian/check-ucf-md5sums
endif

override_dh_auto_test-indep:

override_dh_auto_clean:
	rm -rf debian/build-deb debian/build-udeb
ifeq ($(RUN_TESTS),yes)
	$(MAKE) -C debian/keygen-test clean
endif
	$(MAKE) -C contrib clean

override_dh_auto_install-arch:
	$(MAKE) -C debian/build-deb DESTDIR=`pwd`/debian/tmp install-nokeys

override_dh_auto_install-indep:

override_dh_install-arch:
	# Remove version control tags to avoid unnecessary conffile
	# resolution steps for administrators.
	sed -i '/\$$OpenBSD:/d' \
		debian/tmp/etc/ssh/moduli \
		debian/tmp/etc/ssh/ssh_config \
		debian/tmp/etc/ssh/sshd_config

	dh_install -Nopenssh-client-udeb -Nopenssh-server-udeb
ifeq ($(filter noudeb,$(DEB_BUILD_PROFILES)),)
	dh_install -popenssh-client-udeb -popenssh-server-udeb \
		--sourcedir=debian/build-udeb
endif

	rm -f debian/openssh-tests/usr/lib/openssh/regress/misc/sk-dummy/*.lo

override_dh_installdocs:
	dh_installdocs -Nopenssh-server -Nopenssh-sftp-server
	dh_installdocs -popenssh-server -popenssh-sftp-server \
		--link-doc=openssh-client
	# Avoid breaking dh_installexamples later.
	mkdir -p debian/openssh-server/usr/share/doc/openssh-client

override_dh_installinit:
	dh_installinit -R --name ssh

override_dh_installsystemd:
	dh_installsystemd -popenssh-server ssh.service
	dh_installsystemd -popenssh-server --no-enable ssh.socket
	dh_installsystemd -popenssh-server --no-start rescue-ssh.target
	dh_installsystemd -popenssh-server sshd-keygen.service

debian/openssh-server.sshd.pam: debian/openssh-server.sshd.pam.in
ifeq ($(DEB_HOST_ARCH_OS),linux)
	sed 's/^@IF_KEYINIT@//' $< > $@
else
	sed '/^@IF_KEYINIT@/d' $< > $@
endif

override_dh_installpam: debian/openssh-server.sshd.pam
	dh_installpam --name sshd

override_dh_runit:
	dh_runit -popenssh-server

execute_after_dh_fixperms-arch:
	chmod u+s debian/openssh-client/usr/lib/openssh/ssh-keysign

# Work around dh-exec https://bugs.debian.org/1121699.
override_dh_missing:
	dh_missing --list-missing

override_dh_gencontrol:
	dh_gencontrol -- -V'openssh-server:Recommends=$(server_recommends)'

=== debian/tests/control ===
Tests:
 regress,
Restrictions:
 allow-stderr,
 isolation-container,
 needs-sudo,
Depends:
 devscripts,
 dropbear,
 haveged,
 openssh-tests,
 openssl,
 passwd,
 putty-tools,
 python3-twisted,
 sudo,
 sysvinit-utils,

Tests:
 ssh-gssapi,
Restrictions:
 allow-stderr,
 isolation-container,
 needs-root,
Depends:
 adduser,
 krb5-admin-server,
 krb5-kdc,
 openssh-server-gssapi,

Tests:
 socket-activation,
Restrictions:
 allow-stderr,
 isolation-container,
 needs-sudo,
Depends:
 openssh-server,
 passwd,

Tests:
 xinetd,
Restrictions:
 allow-stderr,
 isolation-container,
 needs-sudo,
Depends:
 openssh-server,
 passwd,
 xinetd,
